# Notes: https://gitea.lemnoslife.com/Benjamin_Loison/Robust_image_source_identification_on_modern_smartphones/issues/25

import os
from PIL import Image
import numpy as np
import sys

sys.path.insert(0, '../../algorithms/image_utils/')

from image_utils import showImageWithMatplotlib, randomGaussianImage, toPilImage

sys.path.insert(0, '../../algorithms/context_adaptive_interpolator/')

from context_adaptive_interpolator import contextAdaptiveInterpolator

datasetPath = 'no_noise_images'
# Note that contrarily to `datasets/fake/`, here we do not have images being Gaussian with `scale` `1` but actual images with pixel values between 0 and 255.
# In addition to the range difference, note that the distribution in the first set of images was a Gaussian and here is very different and specific.
PRNU_FACTOR = 0.15
IMAGE_SIZE_SHAPE = (469, 704)

np.random.seed(0)

#prnuNpArray = 255 * randomGaussianImage(scale = PRNU_FACTOR, size = IMAGE_SIZE_SHAPE)
prnuPil = Image.open('prnu.png').convert('F')
prnuNpArray = np.array(prnuPil) * PRNU_FACTOR

def isIn256Range(x):
    return 0 <= x and x <= 255

for imageName in os.listdir(datasetPath):
    if imageName.endswith('.png'):
        imagePath = f'{datasetPath}/{imageName}'
        imageWithoutPrnuPil = Image.open(imagePath).convert('F')
        imageWithoutPrnuNpArray = np.array(imageWithoutPrnuPil)
        #showImageWithMatplotlib(imageWithoutPrnuNpArray)
        imageWithPrnuNpArray = imageWithoutPrnuNpArray + prnuNpArray
        showImageWithMatplotlib(imageWithPrnuNpArray)
        break
        assert all([isIn256Range(extreme) for extreme in [imageWithPrnuNpArray.max(), imageWithPrnuNpArray.min()]]), 'Adding the PRNU resulted in out of 256 bounds image'
        imageWithPrnuPil = toPilImage(imageWithPrnuNpArray)
        imageWithPrnuCaiPil = contextAdaptiveInterpolator(imageWithPrnuPil.load(), imageWithPrnuPil)
        imageWithPrnuCaiNpArray = np.array(imageWithPrnuCaiPil)
        showImageWithMatplotlib(imageWithPrnuCaiNpArray)
        break

